/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-30 16:43
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N, M, K;

multiset<ll> jelly, gelly;
void apple_swap(ll jels, ll gels){
    // fprintf(stderr, "Swapping %lld jel and %lld gel\n", jels, gels);
    jelly.insert(gels);
    jelly.erase(jelly.find(jels));
    gelly.insert(jels);
    gelly.erase(gelly.find(gels));
}

void solve(){
    // Code goes here ...
    cin >> N >> M >> K;

    vector<ll> vj(N), vg(M);
    R(i, N) cin >> vj[i];
    R(i, M) cin >> vg[i];

    jelly = multiset<ll>(begin(vj), end(vj));
    gelly = multiset<ll>(begin(vg), end(vg));

    ll rounds = min(K, 124LL);
    if(rounds < K and (K - rounds) % 2) rounds++;
    bool jellysturn = 1;
    R(i, rounds){
        if(jellysturn){
            ll minjel = *begin(jelly);
            ll maxgel = *rbegin(gelly);
            if(maxgel > minjel){
                apple_swap(minjel, maxgel);
            }
        }
        else{
            ll maxjel = *rbegin(jelly);
            ll mingel = *begin(gelly);
            if(maxjel > mingel){
                apple_swap(maxjel, mingel);
            }
        }
        jellysturn = not jellysturn;
    }

    // if(K % 2){
    //     if(maxgel > minjel){
    //         apple_swap(minjel, maxgel);
    //     }
    // }
    // else{
    //     if(minjel >= maxgel){ // if i do nothing at first
    //         apple_swap(maxjel, mingel);
    //     }
    //     else{
    //         // jelly's first swap
    //         apple_swap(minjel, maxgel);
    //         // and gelly's first swap
    //         apple_swap(max(maxjel, maxgel), min(mingel, minjel));
    //     }
    // }

    // ll res = accumulate(begin(jelly), end(jelly), 0LL);
    ll res = reduce(begin(jelly), end(jelly));
    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
